//============================================================================
/// \file   capi_valve_test.cpp
/// \author Uwe Kindler
/// \date   19.05.2015
/// \brief  Implementation of 
//============================================================================

//============================================================================
//                                   INCLUDES
//============================================================================
#include <labbcan/c_api/labbCAN_Bus_API.h>
#include <labbcan/c_api/labbCAN_Valve_API.h>
#include <labbcan/common/labbcan_test_helpers.h>

#include <usl/core/Thread.h>
#include <usl/core/PollingTimer.h>
#include <log4cplus/logger.h>
#include <diag/diag.h>


//using namespace Lcl;
using namespace Usl;
#define BOOST_TEST_MODULE capi_valve_test
#include <boost/test/unit_test.hpp>


//============================================================================
//                               GLOBAL DATA
//============================================================================
long Result = 0;


//============================================================================
// Initialize C-API - open bus library
//============================================================================
BOOST_AUTO_TEST_CASE(testCapiOpen)
{
	static const char* DeviceConfigPath = "config/testconfig_qmixsdk";
    using namespace boost::unit_test;
    Result = LCB_Open(DeviceConfigPath, 0);
    CHECK_RETURN_CODE(Result);
    Result = LCB_Close();
    CHECK_RETURN_CODE(Result);
    Result = LCB_Open(DeviceConfigPath, 0);
    CHECK_RETURN_CODE(Result);
    Result = LCB_Close();
    CHECK_RETURN_CODE(Result);
    Result = LCB_Open(DeviceConfigPath, 0);
    REQUIRE_ERR_NOERR(Result);
}


//============================================================================
// Tests if C-API shutdown works properly
//============================================================================
BOOST_AUTO_TEST_CASE(testCapiClose)
{
	Result = LCB_Stop();
    CHECK_RETURN_CODE(Result);

    Result = LCB_Close();
    CHECK_RETURN_CODE(Result);
}




//---------------------------------------------------------------------------
// EOF capi_valve_test.cpp
