# Generated by sila2.code_generator; sila2.__version__: 0.8.0
from __future__ import annotations

from typing import Set

from sila2.client import SilaClient
from sila2.framework import FullyQualifiedFeatureIdentifier

from .batteryservice import BatteryServiceClient, BatteryServiceFeature, LockingFailed, UnlockingFailed
from .systemstatusprovider import SystemStatusProviderClient


class Client(SilaClient):

    SystemStatusProvider: SystemStatusProviderClient

    BatteryService: BatteryServiceClient

    _expected_features: Set[FullyQualifiedFeatureIdentifier] = {
        FullyQualifiedFeatureIdentifier("org.silastandard/core/SiLAService/v1"),
        FullyQualifiedFeatureIdentifier("de.cetoni/core/SystemStatusProvider/v1"),
        FullyQualifiedFeatureIdentifier("de.cetoni/core/BatteryService/v1"),
    }

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)

        self._register_defined_execution_error_class(
            BatteryServiceFeature.defined_execution_errors["UnlockingFailed"], UnlockingFailed
        )

        self._register_defined_execution_error_class(
            BatteryServiceFeature.defined_execution_errors["LockingFailed"], LockingFailed
        )
