# Generated by sila2.code_generator; sila2.__version__: 0.9.2
# -----
# This class does not do anything useful at runtime. Its only purpose is to provide type annotations.
# Since sphinx does not support .pyi files (yet?), so this is a .py file.
# -----

from __future__ import annotations

from typing import TYPE_CHECKING

if TYPE_CHECKING:

    from typing import Iterable, Optional

    from huberchillercontrolservice_types import (
        ChangeSetPoint_Responses,
        ClearAlarmStatus_Responses,
        SetTemperatureControlMode_Responses,
    )
    from sila2.client import ClientMetadataInstance, ClientObservableProperty, ClientUnobservableProperty

    from .huberchillercontrolservice_types import Temperature, TemperatureControlMode


class HuberChillerControlServiceClient:
    """
    Allows to control Huber Chiller devices
    """

    OperatingRangeLimit: ClientUnobservableProperty[RangeLimit]
    """
    The minimum and maximum operating temperatures of the device. These are specific to the device and cannot be changed.
    """

    SetPointRangeLimit: ClientObservableProperty[RangeLimit]
    """
    The minimum and maximum set point temperatures of the device. The minimum value cannot be below the minimum operating range limit and the maximum value cannot be higher than the maximum operating range limit.
    """

    SetPointValue: ClientObservableProperty[Temperature]
    """
    The current set point value of the device.
    """

    InternalActualValue: ClientObservableProperty[Temperature]
    """
    The current actual value of the device. This value is measured by the internal temperature sensor of the device.
    """

    ExternalActualValue: ClientObservableProperty[Temperature]
    """
    The current actual value of the device. This value is measured by the external temperature sensor of the device.
    """

    TemperatureControlMode: ClientObservableProperty[TemperatureControlMode]
    """
    The current temperature control mode (i.e. how the device should operate to reach the set point).
    """

    AlarmStatus: ClientObservableProperty[bool]
    """
    Indicates if the device is currently in an alarm state (true) or not (false). To clear the alarm state use the ClearAlarm command.
    """

    def ChangeSetPoint(
        self, SetPointValue: Temperature, *, metadata: Optional[Iterable[ClientMetadataInstance]] = None
    ) -> ChangeSetPoint_Responses:
        """
        Change the set point value
        """
        ...

    def SetTemperatureControlMode(
        self,
        TemperatureControlMode: TemperatureControlMode,
        *,
        metadata: Optional[Iterable[ClientMetadataInstance]] = None,
    ) -> SetTemperatureControlMode_Responses:
        """
        Set the temperature control mode
        """
        ...

    def ClearAlarmStatus(
        self, *, metadata: Optional[Iterable[ClientMetadataInstance]] = None
    ) -> ClearAlarmStatus_Responses:
        """
        Clears the alarm state of the device if it is in an alarm state. Has no effect if the device is currently not in an alarm state.
        """
        ...
