# Generated by sila2.code_generator; sila2.__version__: 0.8.0
from __future__ import annotations

from typing import Set

from sila2.client import SilaClient
from sila2.framework import FullyQualifiedFeatureIdentifier

from .analoginchannelprovider import AnalogInChannelProviderClient, AnalogInChannelProviderFeature, InvalidChannelIndex
from .analogoutchannelcontroller import (
    AnalogOutChannelControllerClient,
    AnalogOutChannelControllerFeature,
    InvalidChannelIndex,
)
from .digitalinchannelprovider import (
    DigitalInChannelProviderClient,
    DigitalInChannelProviderFeature,
    InvalidChannelIndex,
)
from .digitaloutchannelcontroller import (
    DigitalOutChannelControllerClient,
    DigitalOutChannelControllerFeature,
    InvalidChannelIndex,
)


class Client(SilaClient):

    AnalogInChannelProvider: AnalogInChannelProviderClient

    AnalogOutChannelController: AnalogOutChannelControllerClient

    DigitalOutChannelController: DigitalOutChannelControllerClient

    DigitalInChannelProvider: DigitalInChannelProviderClient

    _expected_features: Set[FullyQualifiedFeatureIdentifier] = {
        FullyQualifiedFeatureIdentifier("org.silastandard/core/SiLAService/v1"),
        FullyQualifiedFeatureIdentifier("de.cetoni/io/AnalogInChannelProvider/v1"),
        FullyQualifiedFeatureIdentifier("de.cetoni/io/AnalogOutChannelController/v1"),
        FullyQualifiedFeatureIdentifier("de.cetoni/io/DigitalOutChannelController/v1"),
        FullyQualifiedFeatureIdentifier("de.cetoni/io/DigitalInChannelProvider/v1"),
    }

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)

        self._register_defined_execution_error_class(
            AnalogInChannelProviderFeature.defined_execution_errors["InvalidChannelIndex"], InvalidChannelIndex
        )

        self._register_defined_execution_error_class(
            AnalogOutChannelControllerFeature.defined_execution_errors["InvalidChannelIndex"], InvalidChannelIndex
        )

        self._register_defined_execution_error_class(
            DigitalOutChannelControllerFeature.defined_execution_errors["InvalidChannelIndex"], InvalidChannelIndex
        )

        self._register_defined_execution_error_class(
            DigitalInChannelProviderFeature.defined_execution_errors["InvalidChannelIndex"], InvalidChannelIndex
        )
