# Generated by sila2.code_generator; sila2.__version__: 0.8.0
from __future__ import annotations

from typing import Set

from sila2.client import SilaClient
from sila2.framework import FullyQualifiedFeatureIdentifier

from .forcemonitoringservice import ForceMonitoringServiceClient
from .pumpdrivecontrolservice import (
    InitializationFailed,
    InitializationNotFinished,
    NotSupported,
    PumpDriveControlServiceClient,
    PumpDriveControlServiceFeature,
)
from .pumpfluiddosingservice import PumpFluidDosingServiceClient
from .pumpunitcontroller import PumpUnitControllerClient
from .syringeconfigurationcontroller import SyringeConfigurationControllerClient


class Client(SilaClient):

    PumpDriveControlService: PumpDriveControlServiceClient

    ForceMonitoringService: ForceMonitoringServiceClient

    PumpFluidDosingService: PumpFluidDosingServiceClient

    PumpUnitController: PumpUnitControllerClient

    SyringeConfigurationController: SyringeConfigurationControllerClient

    _expected_features: Set[FullyQualifiedFeatureIdentifier] = {
        FullyQualifiedFeatureIdentifier("org.silastandard/core/SiLAService/v1"),
        FullyQualifiedFeatureIdentifier("de.cetoni/pumps.syringepumps/PumpDriveControlService/v1"),
        FullyQualifiedFeatureIdentifier("de.cetoni/pumps.syringepumps/ForceMonitoringService/v1"),
        FullyQualifiedFeatureIdentifier("de.cetoni/pumps.syringepumps/PumpFluidDosingService/v1"),
        FullyQualifiedFeatureIdentifier("de.cetoni/pumps.syringepumps/PumpUnitController/v1"),
        FullyQualifiedFeatureIdentifier("de.cetoni/pumps.syringepumps/SyringeConfigurationController/v1"),
    }

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)

        self._register_defined_execution_error_class(
            PumpDriveControlServiceFeature.defined_execution_errors["InitializationFailed"], InitializationFailed
        )

        self._register_defined_execution_error_class(
            PumpDriveControlServiceFeature.defined_execution_errors["InitializationNotFinished"],
            InitializationNotFinished,
        )

        self._register_defined_execution_error_class(
            PumpDriveControlServiceFeature.defined_execution_errors["NotSupported"], NotSupported
        )
