# Generated by sila2.code_generator; sila2.__version__: 0.8.3
# -----
# This class does not do anything useful at runtime. Its only purpose is to provide type annotations.
# Since sphinx does not support .pyi files (yet?), so this is a .py file.
# -----

from __future__ import annotations

from typing import TYPE_CHECKING

if TYPE_CHECKING:

    from typing import Any, Iterable, List, Optional

    from sila2.client import ClientMetadataInstance, ClientObservableProperty
    from waterpurificationservice_types import StartDispensing_Responses, StopDispensing_Responses


class WaterPurificationServiceClient:
    """
    Allows to control water purification devices
    """

    IntakeConductivity: ClientObservableProperty[Conductivity]
    """
    Conductivity of the water coming from the intake
    """

    IntakeTemperature: ClientObservableProperty[Temperature]
    """
    Temperature of the water coming from the intake
    """

    InputPressure: ClientObservableProperty[Pressure]
    """
    The input pressure
    """

    Conductivity: ClientObservableProperty[Conductivity]
    """
    Conductivity of the purified water
    """

    Temperature: ClientObservableProperty[Temperature]
    """
    Temperature of the purified water
    """

    RejectionRate: ClientObservableProperty[Percentage]
    """
    The percentage of water that is rejected during the purification process
    """

    IsDispensing: ClientObservableProperty[bool]
    """
    Whether or not the device is currently dispensing purified water
    """

    IsDispensingPossible: ClientObservableProperty[bool]
    """
    Whether or not it is currently possible to dispense purified water
    """

    BagTankCapacity: ClientObservableProperty[Litre]
    """
    Total capacity of the bag tank holding the purified water
    """

    BagTankAvailableVolume: ClientObservableProperty[Litre]
    """
    Available volume of purified water in the bag tank
    """

    Reminders: ClientObservableProperty[List[Any]]
    """
    A list of upcoming reminders
    """

    Alerts: ClientObservableProperty[List[Any]]
    """
    A list of the currently active alerts
    """

    def StartDispensing(
        self, *, metadata: Optional[Iterable[ClientMetadataInstance]] = None
    ) -> StartDispensing_Responses:
        """
        Start dispensing of purified water. Depending on the device or the configured dispensing mode dispensing might be stopped automatically after a configured period of time (time-controlled mode), after a certain volume has been dosed (volume-controlled mode), or dispensing might not be stopped until StopDispensing is called ("manual" mode).
        """
        ...

    def StopDispensing(
        self, *, metadata: Optional[Iterable[ClientMetadataInstance]] = None
    ) -> StopDispensing_Responses:
        """
        Stop dispensing of purified water. Depending on the device or the configured dispensing mode it might be possible to not only stop dispensing in "manual" mode but also in volume-controlled or time-controlled mode.
        """
        ...
