# Generated by sila2.code_generator; sila2.__version__: 0.8.3

from typing import Optional
from uuid import UUID

from sila2.server import SilaServer

from ...device_drivers.abc import PurificationDeviceInterface
from .feature_implementations.waterpurificationservice_impl import WaterPurificationServiceImpl
from .generated.waterpurificationservice import WaterPurificationServiceFeature

__version__ = "1.8.0"


class Server(SilaServer):
    def __init__(
        self,
        device: PurificationDeviceInterface,
        server_name: str = "",
        server_type: str = "",
        server_description: str = "",
        server_version: str = "",
        server_vendor_url: str = "",
        server_uuid: Optional[UUID] = None,
    ):
        super().__init__(
            server_name=server_name or "Purification Service",
            server_type=server_type or "TestService",
            server_description=server_description or "The SiLA 2 driver for purification devices",
            server_version=server_version or __version__,
            server_vendor_url=server_vendor_url or "https://www.cetoni.com",
            server_uuid=server_uuid,
        )

        self.waterpurificationservice = WaterPurificationServiceImpl(self, device, self.child_task_executor)

        self.set_feature_implementation(WaterPurificationServiceFeature, self.waterpurificationservice)
