# Generated by sila2.code_generator; sila2.__version__: 0.8.3
from __future__ import annotations

from abc import ABC, abstractmethod
from queue import Queue
from typing import TYPE_CHECKING, Optional

from sila2.server import FeatureImplementationBase, MetadataDict

from .stirringservice_types import (
    RPM,
    Percent,
    SetPower_Responses,
    SetRPM_Responses,
    StartStirring_Responses,
    StopStirring_Responses,
)

if TYPE_CHECKING:
    from sila2.server import SilaServer


class StirringServiceBase(FeatureImplementationBase, ABC):

    _IsStirring_producer_queue: Queue[bool]

    _RPM_producer_queue: Queue[RPM]

    _Power_producer_queue: Queue[Percent]

    def __init__(self, parent_server: SilaServer):
        """
        Allows to control stirring devices
        """
        super().__init__(parent_server=parent_server)

        self._IsStirring_producer_queue = Queue()

        self._RPM_producer_queue = Queue()

        self._Power_producer_queue = Queue()

    def update_IsStirring(self, IsStirring: bool, queue: Optional[Queue[bool]] = None):
        """
        Whether the device is currently stirring

        This method updates the observable property 'IsStirring'.
        """
        if queue is None:
            queue = self._IsStirring_producer_queue
        queue.put(IsStirring)

    def IsStirring_on_subscription(self, *, metadata: MetadataDict) -> Optional[Queue[bool]]:
        """
        Whether the device is currently stirring

        This method is called when a client subscribes to the observable property 'IsStirring'

        :param metadata: The SiLA Client Metadata attached to the call
        :return: Optional `Queue` that should be used for updating this property.
            If None, the default Queue will be used.
        """
        pass

    def update_RPM(self, RPM: RPM, queue: Optional[Queue[RPM]] = None):
        """
        The stirring speed in RPM

        This method updates the observable property 'RPM'.
        """
        if queue is None:
            queue = self._RPM_producer_queue
        queue.put(RPM)

    def RPM_on_subscription(self, *, metadata: MetadataDict) -> Optional[Queue[RPM]]:
        """
        The stirring speed in RPM

        This method is called when a client subscribes to the observable property 'RPM'

        :param metadata: The SiLA Client Metadata attached to the call
        :return: Optional `Queue` that should be used for updating this property.
            If None, the default Queue will be used.
        """
        pass

    def update_Power(self, Power: Percent, queue: Optional[Queue[Percent]] = None):
        """
        The stirring power

        This method updates the observable property 'Power'.
        """
        if queue is None:
            queue = self._Power_producer_queue
        queue.put(Power)

    def Power_on_subscription(self, *, metadata: MetadataDict) -> Optional[Queue[Percent]]:
        """
        The stirring power

        This method is called when a client subscribes to the observable property 'Power'

        :param metadata: The SiLA Client Metadata attached to the call
        :return: Optional `Queue` that should be used for updating this property.
            If None, the default Queue will be used.
        """
        pass

    @abstractmethod
    def StartStirring(self, *, metadata: MetadataDict) -> StartStirring_Responses:
        """
        Starts stirring


        :param metadata: The SiLA Client Metadata attached to the call

        """
        pass

    @abstractmethod
    def StopStirring(self, *, metadata: MetadataDict) -> StopStirring_Responses:
        """
        Stops stirring


        :param metadata: The SiLA Client Metadata attached to the call

        """
        pass

    @abstractmethod
    def SetRPM(self, Value: RPM, *, metadata: MetadataDict) -> SetRPM_Responses:
        """
        Set the stirring speed in RPM


        :param Value: The RPM value to set

        :param metadata: The SiLA Client Metadata attached to the call

        """
        pass

    @abstractmethod
    def SetPower(self, Power: Percent, *, metadata: MetadataDict) -> SetPower_Responses:
        """
        Set the stirring power in percent of the maximum power of the device


        :param Power: The power to set

        :param metadata: The SiLA Client Metadata attached to the call

        """
        pass
